#! /usr/bin/env python

types = ['moo::Document', 'ggap::Worksheet', 'ggap::WsWindow', 'ggap::App']

make_type_tmpl = """\
static QScriptValue %(prefix)s_objectToValue(QScriptEngine *engine, %(class)s* const &optr)
{
    return engine->newQObject(optr);
}

void %(prefix)s_valueToObject(const QScriptValue &value, %(class)s* &optr)
{
    optr = dynamic_cast<%(class)s*>(value.toQObject());
}

Q_DECLARE_METATYPE(%(class)s*)

"""

register_type_tmpl = """\
    qScriptRegisterMetaType<%(class)s*>(engine, %(prefix)s_objectToValue, %(prefix)s_valueToObject);
"""

import sys
for t in types:
    sys.stdout.write(make_type_tmpl % {'class': t, 'prefix': t.replace('::', '_')})
print ""
print "static void registerMetaTypes(QScriptEngine *engine)"
print "{"
for t in types:
    sys.stdout.write(register_type_tmpl % {'class': t, 'prefix': t.replace('::', '_')})
print "}"
